stages:
  - build_publish_webservice_image
  - deploy_app
  - deploy_webservice

image: alpine:latest

variables:
  AWS_ACCESS_KEY_ID: $AWS_ACCESS_KEY_ID
  AWS_SECRET_ACCESS_KEY: $AWS_SECRET_ACCESS_KEY
  AWS_DEFAULT_REGION: us-east-2

build_production:
  stage: build_publish_webservice_image
  image: docker:stable
  services:
    - docker:dind
  variables:
    DOCKER_HOST: tcp://docker:2375/
    DOCKER_DRIVER: overlay2
    DOCKER_TLS_CERTDIR: ""
    BACKEND_PRODUCTION_IMAGE: $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG
  before_script:
  - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  script:
    - cd packages/webservice
    - echo $BACKEND_PRODUCTION_IMAGE >> build-prod.env
    - docker build -t $BACKEND_PRODUCTION_IMAGE .
    - docker push $BACKEND_PRODUCTION_IMAGE
  cache:
    key: ${CI_COMMIT_TAG}
    paths:
      - packages/webservice/build-prod.env
    policy: push
  only:
    changes:
      - "packages/webservice/**/*" 
    refs:
      - tags
  except:
    - develop
    - /^release.*$/
    - /^chore.*$/
    - /^feature.*$/
    - /^bugfix.*$/
    - /^hotfix.*$/


deploy-to-ecs-prod:
  stage: deploy_webservice
  image: registry.gitlab.com/gitlab-org/cloud-deploy/aws-base:latest
  variables:
    TASK_DEFINITION_NAME: backend
    ECS_CLUSTER_NAME: bossa-demo
    ECS_SERVICE_NAME: backend-service
  script:
    - cd $CI_PROJECT_DIR/packages/webservice/
    - BACKEND_PRODUCTION_IMAGE=$(cat build-prod.env) && echo $BACKEND_PRODUCTION_IMAGE
    - TASK_DEFINITION=$(aws ecs describe-task-definition --task-definition "$TASK_DEFINITION_NAME" --region "${AWS_DEFAULT_REGION}")
    - NEW_CONTAINER_DEFINITION=$(echo $TASK_DEFINITION | jq --arg IMAGE "$BACKEND_PRODUCTION_IMAGE" '.taskDefinition.containerDefinitions[0].image = $IMAGE | .taskDefinition.containerDefinitions[0]')
    - echo "Registering new container definition..."
    - aws ecs register-task-definition --region "${AWS_DEFAULT_REGION}" --family "${TASK_DEFINITION_NAME}" --container-definitions "${NEW_CONTAINER_DEFINITION}"
    - echo "Updating the service..."
    - aws ecs update-service --region "${AWS_DEFAULT_REGION}" --cluster "${ECS_CLUSTER_NAME}" --service "${ECS_SERVICE_NAME}"  --task-definition "${TASK_DEFINITION_NAME}"
  cache:
    key: ${CI_COMMIT_TAG}
    paths:
      - packages/webservice/build-prod.env
    policy: pull
  only:
    changes:
      - "packages/webservice/**/*" 
    refs:
      - tags
  except:
    - develop
    - /^release.*$/
    - /^chore.*$/
    - /^feature.*$/
    - /^bugfix.*$/
    - /^hotfix.*$/